try (destroydialog SMStruct.SurfaceMorpherHolder)catch()

/* NOTES

Progressive morphing with individual masks on is different to non progressive with masks:
In non progressive mode, the masks mask the target back to the base pose. In progressive, it masks back to the previous target in the progressive list.

This can be easily changed, should it? An optional mode?

*/


global SMStruct
rcmenu 	SMMenu
(
 		--local clone_node, is_cut
		submenu "Log" (
		menuItem mi_clear			"Clear Log"
		)
		--separator sep6
		on mi_clear picked do (
		 smstruct.SurfaceMorpherHolder.feedback.items.count=0
		 smstruct.SurfaceMorpherHolder.feedback.items= smstruct.SurfaceMorpherHolder.feedback.items
		)
)
rcmenu 	SurfaceMorphRCMenu
(
 		--local clone_node, is_cut
		menuItem mi_rename			"Rename"
		menuItem mi_select			"Select node in scene"
		--separator sep6
		on mi_rename picked do (
			SMStruct.surfacemorphermain.targlist.labeledit = true;
			SMStruct.surfacemorphermain.targList.selecteditems.item[0].beginedit()
		
		)
		on mi_select picked do (
			tval = SMStruct.surfacemorphermain.targList.selecteditems.item[0].tag.value
			if tval[1] == #channel then
			(
				-- select first node if there is one
				noder = SMStruct.thisobj.gettargetnode tval[2] 1
				if isvalidnode noder then select noder;
				else messagebox "No node in target - deleted or a PC2?" title:"Surface Morpher"
			) else (
				noder = SMStruct.thisobj.gettargetnode tval[2] tval[3]
				if isvalidnode noder then select noder;
				else messagebox "No node in target detected" title:"Surface Morpher"
			)
			
		
		)
)
struct surfaceMorphStruct
(
	surfaceMorpher,
	surfaceMorpherGlobals,
	surfacemorphermain,
	surfacemorpherpaint,
	SurfaceMorpherHolder,
	surfaceMorphvalueChanger ,
	surfaceMorphSpinnerChanger ,
	thisObj,
	thisNode,
	minval,
	maxval,
	progoffset,
	progmultiplier,
	wasShowVertexOn,
	origVertexShowing,
	paintingDidTakePlace,
	paintNode,
	dialogposval,
	mouseIsDown
,
	fn Endpaint = -- this is called by the plugin itself
	(
	--	print "ending paint session"
		SMStruct.thisobj.endpaint();
		surfacemorpherpaint.paintselected.checked = false
		smstruct.thisNode.showVertexColors = smstruct.wasShowVertexOn 
		smstruct.origVertexShowing= smstruct.thisNode.vertexColorType 
		callbacks.removescripts id:#isurMorph

	)
,
	fn setChannelColor which colorname =
	(
		print "setChannelColor"
		print which
		print colorname
	)
,
	fn updateFeedback stringer channel:-1 target:-1 type:0 =
	(
		print type
		valstart = case type of
		(
			1:"Error: "
			3:"ERROR: "
			2:"Info: "
			default:"Message: "
		)
		if channel == -1 then
			valprint = (stringer)
		else 
			if target != -1 then
						valprint = (stringer + " :Channel=" + channel as string+":Target=" + target as string)
				else
					valprint =  (stringer + " :Channel=" + channel as string)
					
		valprint = valstart + valprint;
		if not SurfaceMorpherHolder.open do(
			print valprint;
			 return();
		 )
		if surfaceMorpherHolder.feedback.items.count > 20 do deleteitem surfaceMorpherHolder.feedback.items 1
		--SurfaceMorpherHolder.feedback.items = SurfaceMorpherHolder.feedback.items
		append SurfaceMorpherHolder.feedback.items valprint
		SurfaceMorpherHolder.feedback.items = SurfaceMorpherHolder.feedback.items
		SurfaceMorpherHolder.feedback.selection = SurfaceMorpherHolder.feedback.items.count
		
		if type == #errorMajor do
		(
			print "ERROR MAJOR"
			-- set all channels red I'd say...
		)
	)
,
	fn openTV channelr which =
	(
		case which of
		(
		  #progMO: cntr = smstruct.thisobj.ProgressionMaskOffset[channelr].controller
		  #progMM: cntr = smstruct.thisobj.ProgressionMaskMultiplier[channelr].controller
		  #prog: cntr = smstruct.thisobj.ProgressionCurve[channelr].controller
		  default: cntr = smstruct.thisobj.TargetWeight[channelr].controller
		  
		)
		print cntr
		if cntr == undefined do return()
		if (tv = trackviews.gettrackview "Surface Morph") == undefined do
		(
			trackview.open "Surface Morph"
			(tv = trackviews.gettrackview "Surface Morph") 
		)
		tv.expandtracks()
		try(		
		tv.selecttrackbyindex (tv.getindex cntr) true
		tv.zoomselected()
		)catch()
	)
,
	fn makeDynSurfaceMorphRoll =
	(
		rollText = "" as stringstream;
		format "global SMStruct\n" to:rollText
		format "rollout surfaceMorpher \"Surface Morpher Channels\" width:500\n" to:rollText
		format "(\n" to:rolltext
		
		-- using selection 1?....
		--if 
		--local thisobj;
		---if SMStruct.SurfaceMorpherHolder!= undefined AND SMStruct.SurfaceMorpherHolder.thisobj != undefined do
		--	thisObj = SMStruct.SurfaceMorpherHolder.thisObj;
		--print SMStruct.thisobj
		local thisobj = SMStruct.thisobj;
		if isproperty thisObj #targetlist do (
			for i in 1 to SMStruct.thisobj.getChannelCount() do (
				if SMStruct.thisobj.Enabledlist[i] == 0 do continue;
				format ("spinner wght" + i as string + "  \"" + smstruct.thisobj.GetChannelName i +"\" range:["+ smstruct.thisObj.minrange[i] as string + ","+ smstruct.thisObj.maxrange[i] as string + ",1.] fieldwidth:45 offset:[-20,0] scale:0.01 across:5\n") to:rollText
				format ("slider sld_wght" + i as string + "  \"\" width:400 ticks:0 range:["+ smstruct.thisObj.minrange[i] as string + ","+ smstruct.thisObj.maxrange[i] as string + ",1.] offset:[00,0]\n") to:rollText
				format ("button zero" + i as string + "  \"Zero\" width:30 offset:[240,0]\n") to:rollText
				format ("button key" + i as string + "  \"Key\" width:30 offset:[150,0]\n") to:rollText
				format ("button edit" + i as string + "  \"Edit\" width:30 offset:[50,0]\n") to:rollText
				
				if SMStruct.thisobj.GetUsePC2 i 1 == 1 do
				(
					--format ("spinner prog" + i as string + "  \"PC2 Progression:\" range:["+ smstruct.thisObj.minrange[i] as string + ","+ smstruct.thisObj.maxrange[i] as string + ",1.] offset:[-50,0] fieldwidth:45 scale:0.01 across:3\n") to:rollText
					--format ("slider sld_prog" + i as string + "  \"\" width:400 ticks:0 range:["+ smstruct.thisObj.minrange[i] as string + ","+ smstruct.thisObj.maxrange[i] as string + ",1.] offset:[-35,0]\n") to:rollText
					format ("spinner prog" + i as string + "  \"PC2 Progression:\" range:[0,1, 1.] offset:[-50,0] fieldwidth:45 scale:0.01 across:3\n") to:rollText
					format ("slider sld_prog" + i as string + "  \"\" width:400 ticks:0 range:[0,1, 1.] offset:[-35,0]\n") to:rollText
					format ("button edit_prog" + i as string + "  \"Edit\" width:30 offset:[40,0]\n") to:rollText
					format ("spinner progMO" + i as string + "  \"PC2 ProgMaskOffset:\" range:[-2,2,0.] offset:[-50,0] fieldwidth:45 scale:0.01 across:3\n") to:rollText
					format ("slider sld_progMO" + i as string + "  \"\" width:400 ticks:0 range:[-2,2,0.] offset:[-35,0]\n") to:rollText
					format ("button edit_progMO" + i as string + "  \"Edit\" width:30 offset:[40,0]\n") to:rollText
					format ("spinner progMM" + i as string + "  \"PC2 ProgMaskMultiplier:\" range:[-2,2,1.] offset:[-50,0] fieldwidth:45 scale:0.01 across:3\n") to:rollText
					format ("slider sld_progMM" + i as string + "  \"\" width:400 ticks:0 range:[-2,2,0.] offset:[-35,0]\n") to:rollText
					format ("button edit_progMM" + i as string + "  \"Edit\" width:30 offset:[40,0]\n") to:rollText
				)
				if SMStruct.thisobj.GetProgTargetCount i > 1 do
				(
					--format ("spinner prog" + i as string + "  \"Progression:\" range:["+ smstruct.thisObj.minrange[i] as string + ","+ smstruct.thisObj.maxrange[i] as string + ",1.] offset:[-50,0] fieldwidth:45 scale:0.01 across:3\n") to:rollText
					--format ("slider sld_prog" + i as string + "  \"\" width:400 ticks:0 range:["+ smstruct.thisObj.minrange[i] as string + ","+ smstruct.thisObj.maxrange[i] as string + ",1.] offset:[-35,0]\n") to:rollText
					format ("spinner prog" + i as string + "  \"Progression:\" range:[0,1, 1.] offset:[-50,0] fieldwidth:45 scale:0.01 across:3\n") to:rollText
					format ("slider sld_prog" + i as string + "  \"\" width:400 ticks:0 range:[0,1, 1.] offset:[-35,0]\n") to:rollText
					format ("button edit_prog" + i as string + "  \"Edit\" width:30 offset:[40,0]\n") to:rollText
				)
				--
				format ("on wght" + i as string + " changed value do (sld_wght" + i as string+".value = value;SMStruct.thisobj.weightlist["+ i as string+"] = value; if SMStruct.thisobj.weightlist["+ i as string+"].controller != undefined do wght" + i as string + ".controller = sld_wght" + i as string + ".controller = SMStruct.thisobj.weightlist["+ i as string+"].controller )\n") to:rollText
				format ("on sld_wght" + i as string + " changed value do (wght" + i as string+".value = value;SMStruct.thisobj.weightlist["+ i as string+"] = value; if SMStruct.thisobj.weightlist["+ i as string+"].controller != undefined do wght" + i as string + ".controller = sld_wght" + i as string + ".controller = SMStruct.thisobj.weightlist["+ i as string+"].controller )\n") to:rollText
				format ("on sld_prog" + i as string + " changed value do (prog" + i as string+".value = value;SMStruct.thisobj.ProgressionCurve["+ i as string+"] = value; if SMStruct.thisobj.ProgressionCurve["+ i as string+"].controller != undefined do prog" + i as string + ".controller = sld_prog" + i as string + ".controller = SMStruct.thisobj.ProgressionCurve["+ i as string+"].controller )\n") to:rollText
				format ("on sld_progMO" + i as string + " changed value do (progMO" + i as string+".value = value;SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"] = value; if SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"].controller != undefined do progMO" + i as string + ".controller = sld_progMO" + i as string + ".controller = SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"].controller )\n") to:rollText
				format ("on sld_progMM" + i as string + " changed value do (progMM" + i as string+".value = value;SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"] = value; if SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"].controller != undefined do progMM" + i as string + ".controller = sld_progMM" + i as string + ".controller = SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"].controller )\n") to:rollText
				format ("on zero" + i as string + " pressed do (wght" + i as string+".value = sld_wght" + i as string+".value = 0;SMStruct.thisobj.weightlist["+ i as string+"] = 0.0f; if SMStruct.thisobj.weightlist["+ i as string+"].controller != undefined do wght" + i as string + ".controller = sld_wght" + i as string + ".controller = SMStruct.thisobj.weightlist["+ i as string+"].controller )\n") to:rollText
				format ("on key" + i as string + " pressed do (with animate on (SMStruct.thisobj.weightlist["+ i as string+"] = SMStruct.thisobj.weightlist["+ i as string+"]); if SMStruct.thisobj.weightlist["+ i as string+"].controller != undefined do wght" + i as string + ".controller = sld_wght" + i as string + ".controller = SMStruct.thisobj.weightlist["+ i as string+"].controller )\n") to:rollText
				format ("on edit" + i as string + " pressed do ( smstruct.openTV " + i as string  +" #chan   )\n") to:rollText
				if SMStruct.thisobj.GetUsePC2 i 1 == 1 do
				(
					format ("on prog" + i as string + " changed value do (sld_prog" + i as string+".value = value;SMStruct.thisobj.ProgressionCurve["+ i as string+"] = value; if SMStruct.thisobj.ProgressionCurve["+ i as string+"].controller != undefined do prog" + i as string + ".controller = sld_prog" + i as string + ".controller = SMStruct.thisobj.ProgressionCurve["+ i as string+"].controller )\n") to:rollText
					format ("on progMO" + i as string + " changed value do (sld_progMO" + i as string+".value = value;SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"] = value; if SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"].controller != undefined do progMO" + i as string + ".controller = sld_progMO" + i as string + ".controller = SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"].controller )\n") to:rollText
					format ("on progMM" + i as string + " changed value do (sld_progMM" + i as string+".value = value;SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"] = value; if SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"].controller != undefined do progMM" + i as string + ".controller = sld_progMM" + i as string + ".controller = SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"].controller )\n") to:rollText
					format ("on edit_prog" + i as string + " pressed do ( smstruct.openTV " + i as string  +" #prog   )\n") to:rollText
					format ("on edit_progMO" + i as string + " pressed do ( smstruct.openTV " + i as string  +" #progMO   )\n") to:rollText
					format ("on edit_progMM" + i as string + " pressed do ( smstruct.openTV " + i as string  +" #progMM   )\n") to:rollText
				)
				if SMStruct.thisobj.GetProgTargetCount i > 1 do
				(
					format ("on prog" + i as string + " changed value do (sld_prog" + i as string+".value = value;SMStruct.thisobj.ProgressionCurve["+ i as string+"] = value; if SMStruct.thisobj.ProgressionCurve["+ i as string+"].controller != undefined do prog" + i as string + ".controller = sld_prog" + i as string + ".controller = SMStruct.thisobj.ProgressionCurve["+ i as string+"].controller )\n") to:rollText
					format ("on edit_prog" + i as string + " pressed do ( smstruct.openTV " + i as string  +" #prog   )\n") to:rollText
				)
			)
		)
		format ("on surfaceMorpher open do(\n") to:rollText;
			-- put on open handler here
			for i in 1 to SMStruct.thisobj.getChannelCount() do (
				if SMStruct.thisobj.Enabledlist[i] == 0 do continue;
				format ("sld_wght" + i as string + ".value = (SMStruct.thisobj.weightlist["+ i as string+"]);sld_wght" + i as string + ".changed (sld_wght" + i as string + ".value)\n") to:rollText
				if SMStruct.thisobj.GetUsePC2 i 1 == 1 do
				(
					format ("sld_prog" + i as string + ".value = (SMStruct.thisobj.ProgressionCurve["+ i as string+"]);sld_prog" + i as string + ".changed (sld_prog" + i as string + ".value) \n") to:rollText
					format ("sld_progMO" + i as string + ".value = (SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"] );sld_progMO" + i as string + ".changed (sld_progMO" + i as string + ".value) \n") to:rollText
					format ("sld_progMM" + i as string + ".value = (SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"]);sld_progMM" + i as string + ".changed (sld_progMM" + i as string + ".value) \n") to:rollText
				)
				if SMStruct.thisobj.GetProgTargetCount i > 1 do
				(
					format ("sld_prog" + i as string + ".value = (SMStruct.thisobj.ProgressionCurve["+ i as string+"]);sld_prog" + i as string + ".changed (sld_prog" + i as string + ".value)\n") to:rollText
				)
			)
		format ")\n" to:rolltext
		format ")SMStruct.surfaceMorpher =surfaceMorpher \n" to:rolltext
		--print rolltext
		execute (rollText as string)
	)
,
	fn updateUI = (
		
			-- now do weights:
			--print SMStruct.thisobj
			if SMStruct.thisobj != undefined do(
				
				--surfacemorphermain
				for i in 1 to SMStruct.thisobj.getChannelCount()  do 
				(
				--print i
				if SMStruct.thisobj.Enabledlist[i] == 0 do continue;
				execute ("surfaceMorpher.wght" + i as string + ".value = SMStruct.thisobj .weightlist["+ i as string+"]\n")
				execute ("if SMStruct.thisobj.weightlist["+ i as string+"].controller != undefined do surfaceMorpher.wght" + i as string + ".controller = SMStruct.thisobj.weightlist["+ i as string+"].controller\n")
				execute ("surfaceMorpher.sld_wght" + i as string + ".value = SMStruct.thisobj.weightlist["+ i as string+"]\n")
				execute ("if SMStruct.thisobj.weightlist["+ i as string+"].controller != undefined do surfaceMorpher.sld_wght" + i as string + ".controller = SMStruct.thisobj.weightlist["+ i as string+"].controller\n")
				try(
					execute ("surfaceMorpher.sld_prog" + i as string + ".value = SMStruct.thisobj.ProgressionCurve["+ i as string+"]\n")
				)catch()
				try(
					execute ("if SMStruct.thisobj.ProgressionCurve["+ i as string+"].controller != undefined do surfaceMorpher.sld_prog" + i as string + ".controller = SMStruct.thisobj.ProgressionCurve["+ i as string+"].controller\n")
				)catch()
				try(
					execute ("if SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"].controller != undefined do surfaceMorpher.sld_progMO" + i as string + ".controller = SMStruct.thisobj.ProgressionMaskOffset["+ i as string+"].controller\n")
				)catch()
				try(
					execute ("if SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"].controller != undefined do surfaceMorpher.sld_progMM" + i as string + ".controller = SMStruct.thisobj.ProgressionMaskMultiplier["+ i as string+"].controller\n")
				)catch()
				)
				--surfaceMorpher.picker.caption = surfaceMorpher.picker.object.name
			)
			surfacemorphermain.targlist.columns.item[1].text = surfacemorphermain.targlist.columns.item[1].text
		)
,
	fn updateGlobalUI =
	(
		--print "updateGlobalUI "
			--Populate the UI control values:
			surfacemorphermain.recacheSel.checked = SMStruct.thisobj.ReCacheReferenceSelection
			try(surfacemorphermain.mode.selection = SMStruct.thisobj.mode+1)catch()
			surfacemorpherglobals.refTargMapChan.value = SMStruct.thisobj.ReferenceMapChannel
			surfacemorpherglobals.stackMapChan.value = SMStruct.thisobj.StackMapChannel
			surfacemorpherglobals.morphUVdom.value = SMStruct.thisobj.MorphUVDominance
			surfacemorphermain.lockCaching.state =  if SMStruct.thisobj.lockCaching == 1 then true else false
			
			surfacemorphermain.cacheref.state = SMStruct.thisobj.cachereference
			surfacemorphermain.dodebug.state = if SMStruct.thisobj.debugOn == 1 then true else false
			--dointerp.state = if SMStruct.thisobj.InterpProgressive == 1 then true else false
			
			SurfaceMorpherGlobals.surfaceAlgo.selection = SMStruct.thisobj.SurfaceAlgorithm + 1
			if SMStruct.thisobj.SurfaceAlgorithm != 0 then
			(
				surfacemorpherglobals.morphuvdom.enabled = false;
				surfacemorpherglobals.stackmapchan.enabled = false;
				surfacemorpherglobals.reftargmapchan.enabled = false;
			)
			else (
				surfacemorpherglobals.morphuvdom.enabled = true;
				surfacemorpherglobals.stackmapchan.enabled = true;
				surfacemorpherglobals.reftargmapchan.enabled = true;
			)
			--print  "--"
			--print SMStruct.thisobj.ReCacheReferenceSelection 
			if SMStruct.thisobj.referenceobject != undefined then
				try(surfacemorphermain.refName.caption = SMStruct.thisobj.referenceobject.name)catch()
			else surfacemorphermain.refName.caption = "Captured from Stack"
			surfacemorpherPaint.showpaint.state = if SMStruct.thisobj.DisplayPaint == 1 then true else false
			surfacemorpherPaint.showpaintchannel.value = SMStruct.thisobj.DisplayPaintChannel
			surfacemorpherPaint.blursteps.value = smstruct.thisobj.paintblursteps;
			surfacemorpherPaint.colweights.state = if smstruct.thisobj.ColorPaintDisplay == 1 then true else false;
			surfacemorpherPaint.blurmult.value = smstruct.thisobj.paintblurmult
			
			SurfaceMorpherGlobals.blurmorph.checked = if smstruct.thisobj.DoMorphBlur == 1 then true else false;
			SurfaceMorpherGlobals.morphblursteps.value = smstruct.thisobj.MorphBlurSteps
			SurfaceMorpherGlobals.morphblurmult.value = smstruct.thisobj.MorphBlurMult
			SurfaceMorpherGlobals.doOrtho.checked = if smstruct.thisobj.Orthogonalize == 1 then true else false
			SurfaceMorpherGlobals.whichUp.value = smstruct.thisobj.upvector
			
			SurfaceMorpherGlobals.doWeightedNorms.checked = if smstruct.thisobj.DoWeightedNorms == 1 then true else false


			SurfaceMorpherGlobals.doDisplay.checked = if smstruct.thisobj.DisplayReferenceTransforms == 1 then true else false
			SurfaceMorpherGlobals.DisplayScale.value = smstruct.thisobj.DisplayReferenceTransformsScale 
			
	)
,	
	fn AsBoolean input = if input == 1 then return true else return false;
,
	fn updateChannelUI =
	(
		--print "updateUI"
		
		-- first get selection:
		numsel = surfacemorphermain.targlist.selecteditems.count
		
		
		if numsel == 0 then (
			surfacemorphermain.disableChannelUI()
			surfacemorpherpaint.disableUI()
			return()
		) else (
			surfacemorphermain.enableChannelUI()
			surfacemorpherpaint.enableUI()
		)
		
		if numsel == 1 do
		(	
			whichItems = surfacemorphermain.targList.selecteditems.item[0].tag.value
			--print whichItems;
			if whichItems[1] == #Channel then -- this just uses target 1
			(
				channelindex = whichItems[2];
				targetIndex = 1;
			) else (
			
				channelindex = whichItems[2];
				targetIndex = whichItems[3];
				
			)
			i = channelindex
			surfacemorphermain.morphtype.selection = SMStruct.thisobj.morphtype[i] + 1;
			surfacemorphermain.MorphMode.selection = SMStruct.thisobj.MorphMode[i] + 1;
			surfacemorphermain.rangemin .value = SMStruct.thisobj.MinRange[i];
			surfacemorphermain.rangemax .value = SMStruct.thisobj.MaxRange[i];
			surfacemorphermain.useTargSelection.state = if SMStruct.thisobj.usetargetselection[i] == 0 then false else true
				surfacemorphermain.invertTargSelection .state = if SMStruct.thisobj.usetargetselection[i] == -1 then true else false
			surfacemorphermain.useReferenceSelection.state = if SMStruct.thisobj.usereferenceselection[i] == 0 then false else true
				surfacemorphermain.invertRefSelection.state = if SMStruct.thisobj.usereferenceselection[i] == -1 then true else false;
			surfacemorphermain.usePaintMask.state = if (SMStruct.thisobj.GetLocalUsePaint i targetIndex == 0) then false else true;
				surfacemorphermain.invertPaintMask .state = if (SMStruct.thisobj.GetLocalUsePaint i targetIndex == -1) then true else false;
			surfacemorphermain.useMap.state = if SMStruct.thisobj.UseMap[i] == 0 then false else true
				surfacemorphermain.invertMapMask .state = if SMStruct.thisobj.UseMap[i] == -1 then true else false
			surfacemorphermain.useStackSelection.state = if SMStruct.thisobj.useStackSelection[i] == 0 then false else true
			surfacemorphermain.useMapChannel .value = SMStruct.thisobj.WhichMap[i]
			surfacemorphermain.usemapRGB .selection = SMStruct.thisobj.WhichChannel[i] + 1
			surfacemorphermain.clampMapMask .state = if SMStruct.thisobj.clampMap[i] == 0 then false else true
			surfacemorphermain.recacheSelection .state = if SMStruct.thisobj.ReCacheSelectionEnable[i] == 0 then false else true
		--	surfacemorphermain.doInterpolate .state = if SMStruct.thisobj.UseInterpolation[i] == 0 then false else true
			surfacemorphermain.interpolationAlgorithm.selection =  SMStruct.thisobj.InterpolationType[i] + 1
			if SMStruct.thisobj.InterpolationType[i] == 2 then 
				surfacemorphermain.hermiteTension.enabled = surfacemorphermain.hermiteBias.enabled = true;
			else
				surfacemorphermain.hermiteTension.enabled = surfacemorphermain.hermiteBias.enabled = false;
			surfacemorphermain.hermiteTension.value =  SMStruct.thisobj.GetHermiteTension i;
			surfacemorphermain.hermiteBias.value =  SMStruct.thisobj.GetHermiteBias i;
			surfacemorphermain.maskInterpToBase .state = if SMStruct.thisobj.MaskTargetToBase[i] == 0 then false else true
			surfacemorphermain.progoffset .value = SMStruct.thisobj.GetProgTargetOffset i targetIndex
			surfacemorphermain.targetMultiplier .value = SMStruct.thisobj.GetProgTargetMultiplier i targetIndex
			surfacemorphermain.LocalMorphMode.selection = (SMStruct.thisobj.GetLocalMorphMode i targetIndex) + 2;

			-- pc2 stuff
			surfacemorphermain.usepc2.checked = AsBoolean (SMStruct.thisobj.GetUsePC2 channelindex targetindex)
			surfacemorphermain.preloadpc2.checked = AsBoolean (SMStruct.thisobj.GetDoPreloadPC2 channelindex targetindex)
			surfacemorphermain.maskpc2throughprogression .checked = AsBoolean (SMStruct.thisobj.GetMaskThroughProg channelindex) -- this is per channel
			surfacemorphermain.pc2filename.text = (SMStruct.thisobj.GetPC2filename channelindex targetindex)
			try(
			surfacemorphermain.ProgressionOutOfRangeHandling.selection = SMStruct.thisobj.OutOfRangeProgressionHandling[channelindex] + 1
			)catch()
			try(
			surfacemorphermain.WeightOutOfRangeHandling.selection = SMStruct.thisobj.OutOfRangeWeightHandling[channelindex] + 1
			)catch()
		)
		return();
	)
,
fn populatelist clear:false =
		(
			print "populatelist "
			
			
			-- store selectionopen d
			selarray = for i in 1 to surfacemorphermain.targlist.selecteditems.count collect surfacemorphermain.targlist.selecteditems.item[i-1].index
			if clear == true do
			(
				-- clear here
				surfacemorphermain.targlist.items.clear();
			)
			
			
			-- add imagelist:
			
			local hImgList 	= dotNetObject "System.Windows.Forms.ImageList"
			local imgSize 		= dotNetObject "System.Drawing.Size" 16 16
			hImgList.imagesize	= imgSize
			local bColor 	= dotNetClass "System.Drawing.Color"
			hImgList.transparentColor = bColor.fromARGB 125 125 125	
			local img  		= dotNetClass "System.Drawing.Image"
		-- add bitmaps
		basename = getdir #UI + "icons/"
		fname = basename + "sm_c.bmp"
		if doesfileexist fname do
		(
			local dnBitmap = dotNetObject "System.Drawing.Bitmap" fName
			hImgList.images.add dnBitmap
		)
		fname = basename + "sm_ct.bmp"
		if doesfileexist fname do
		(
			local dnBitmap = dotNetObject "System.Drawing.Bitmap" fName
			hImgList.images.add dnBitmap
		)
		fname = basename + "sm_pt.bmp"
		if doesfileexist fname do
		(
			local dnBitmap = dotNetObject "System.Drawing.Bitmap" fName
			hImgList.images.add dnBitmap
		)
			
			surfacemorphermain.targlist.SmallImageList = hImgList
			
			--print SMStruct.thisobj
			if SMStruct.thisobj == undefined do return()
			for i in 1 to SMStruct.thisobj.getChannelCount() do (
				
				-- deal with items that show in the target list only if there is more than one channel
				numprogs = SMStruct.thisobj.GetProgTargetCount i

				local lis = surfacemorphermain.targlist.items.add \
					(if numprogs == 1 then SMStruct.thisobj.getchannelname i else (SMStruct.thisobj.getchannelname i + ":" + numprogs as string + " targets") )
				lis.tag = dotNetMXSValue #(#Channel, i)
				lis.checked = if SMStruct.thisobj.enabledlist[i] == 0 then false else true;
				local li;
				li = lis.subitems.add ""
				if numprogs == 1 then
				(
					li.text = if SMStruct.thisobj.GetCacheMe i 1 == 0 then "false" else "true"
				)
				li = lis.subitems.add ""
				li.text = SMStruct.thisobj.minrange[i] as string
				li = lis.subitems.add ""
				li.text = SMStruct.thisobj.maxrange[i] as string
				li = lis.subitems.add ""
				li.text = if SMStruct.thisobj.usetargetselection[i] == 0 then "false" else "true"
				li = lis.subitems.add ""
				li.text = if SMStruct.thisobj.UseMap[i] == 0 then "false" else "true"
				-- this is blank for the sub-target display, if it is subtarget
				li = lis.subitems.add ""

				if numprogs == 1 then
				(
					li.text = (if (SMStruct.thisobj.GetLocalUsePaint i 1) == 1 then "true" else "false") -- always 1		
					lis.imageindex = 1;
				) else (
					if SMStruct.thisobj.enabledlist[i] == 0 do 
					(
						lis.imageindex = 0;
						--local lisS = surfacemorphermain.targlist.items.add ()
						continue;
					)
					for n in 1 to numprogs do
					(
						lis.imageindex = 0;
						local lisS = surfacemorphermain.targlist.items.add ((SMStruct.thisobj.GetTargetName i n) +" : " + (SMStruct.thisobj.GetTargetNodeName i n))
						lisS.checked = 	if SMStruct.thisobj.GetisEnabled i n == 1 then true else false
						lisS.tag = dotNetMXSValue #(#Target, i, n)
						lisS.imageindex = 2;
						lisS.indentcount = 1
						li = lisS.subitems.add ""
						li.text = if SMStruct.thisobj.GetCacheMe i n == 0 then "false" else "true"
						
						li = lisS.subitems.add ""
						li = lisS.subitems.add ""
						li = lisS.subitems.add ""
						li = lisS.subitems.add ""
						li = lisS.subitems.add (if (SMStruct.thisobj.GetLocalUsePaint i n) == 1 then "true" else "false")
					)
				)
			)
						for i in selarray do
			(
				if surfacemorphermain.targlist.items.count > i do
					surfacemorphermain.targlist.items.item[i].selected = true;
			)
		)
,
	fn addChannelData =
	(
	
	)
,
	fn Addpc2Channel pc2filename =
	(
		SMStruct.thisobj.AddPC2Target pc2filename (SMStruct.thisobj.GetChannelCount() + 1);
		SMStruct.thisobj.SetChannelName (SMStruct.thisobj.GetChannelCount()) ("PC2:" + getfilenamefile pc2filename);
		index = SMStruct.thisobj.GetChannelCount();
			
	--	SMStruct.thisobj.SetPC2filename index 1 pc2filename
	--	SMStruct.thisobj.SetUsePC2 index 1 1
	--	SMStruct.thisobj.SetDoPreloadPC2 index 1 1
	--	SMStruct.thisobj.SetMaskThroughProg  index 1
-- standard build stuff:
		append SMStruct.thisobj.EnabledList 1
		append SMStruct.thisobj.WeightList 1
		append SMStruct.thisobj.CachedList 1
		append SMStruct.thisobj.MorphType 1
		append SMStruct.thisobj.UVDominance 0	
		append SMStruct.thisobj.MinRange 0	
		append SMStruct.thisobj.MaxRange 1	
		append SMStruct.thisobj.UseTargetSelection 0	
		append SMStruct.thisobj.UseReferenceSelection 0	
		append SMStruct.thisobj.ReCacheSelectionEnable 0	
		append SMStruct.thisobj.UseMap 0	
		append SMStruct.thisobj.clampMap 0	
		append SMStruct.thisobj.WhichMap 0	
		append SMStruct.thisobj.WhichChannel 0	
		
	--	append SMStruct.thisobj.TargetNames i.name; -- this needs to be removed from the pblock...
		append SMStruct.thisobj.MorphMode 0;
		append SMStruct.thisobj.MapChannel 1;
		append SMStruct.thisobj.UseInterpolation 0;
		append SMStruct.thisobj.InterpolationType 0;
		append SMStruct.thisobj.MaskTargetToBase 1;
		append SMStruct.thisobj.ProgressionCurve 0;
		append SMStruct.thisobj.OutOfRangeProgressionHandling 0;
		append SMStruct.thisobj.OutOfRangeWeightHandling 0;
		append SMStruct.thisobj.usestackselection 1;
		append SMStruct.thisobj.ProgressionMaskOffset 0;
		append SMStruct.thisobj.ProgressionMaskMultiplier 1;
		-- animate this
		with animate on
		(
			at time 0
				SMStruct.thisobj.ProgressionCurve[SMStruct.thisobj.ProgressionCurve.count] = 0;
			at time 100
				SMStruct.thisobj.ProgressionCurve[SMStruct.thisobj.ProgressionCurve.count] = 1;
			-- make linear:	
			SMStruct.thisobj.ProgressionCurve[SMStruct.thisobj.ProgressionCurve.count].controller.keys[1].outtangenttype = #linear
			SMStruct.thisobj.ProgressionCurve[SMStruct.thisobj.ProgressionCurve.count].controller.keys[2].intangenttype = #linear
		)
			smstruct.rebuilddynamicrollout();
		surfacemorphermain.targlist.columns.item[1].text = surfacemorphermain.targlist.columns.item[1].text
		populatelist clear:true	
	)
,
	fn AddChannels objs =
	(
		for i in objs do
			(
				if i == thisNode do continue;
				SMStruct.thisobj.AddMorphTarget i (SMStruct.thisobj.GetChannelCount() + 1);
				SMStruct.thisobj.SetChannelName (SMStruct.thisobj.GetChannelCount()) i.name;
				--append SMStruct.thisobj.TargetList i
				append SMStruct.thisobj.EnabledList 1
				append SMStruct.thisobj.WeightList 1
				append SMStruct.thisobj.CachedList 1
				append SMStruct.thisobj.MorphType 1
				append SMStruct.thisobj.UVDominance 0	
				append SMStruct.thisobj.MinRange 0	
				append SMStruct.thisobj.MaxRange 1	
				append SMStruct.thisobj.UseTargetSelection 0	
				append SMStruct.thisobj.UseReferenceSelection 0	
				append SMStruct.thisobj.ReCacheSelectionEnable 0	
				append SMStruct.thisobj.UseMap 0	
				append SMStruct.thisobj.clampMap 0	
				append SMStruct.thisobj.WhichMap 0	
				append SMStruct.thisobj.WhichChannel 0	
				
			--	append SMStruct.thisobj.TargetNames i.name; -- this needs to be removed from the pblock...
				append SMStruct.thisobj.MorphMode 0;
				append SMStruct.thisobj.MapChannel 1;
				append SMStruct.thisobj.UseInterpolation 0;
				append SMStruct.thisobj.InterpolationType 0;
				append SMStruct.thisobj.MaskTargetToBase 1;
				append SMStruct.thisobj.ProgressionCurve 0;
				append SMStruct.thisobj.OutOfRangeProgressionHandling 0;
				append SMStruct.thisobj.OutOfRangeWeightHandling 0;
				append SMStruct.thisobj.usestackselection 1;
				append SMStruct.thisobj.ProgressionMaskOffset 0;
				append SMStruct.thisobj.ProgressionMaskMultiplier 1;
				-- animate this
				with animate on
				(
					at time 0
						SMStruct.thisobj.ProgressionCurve[SMStruct.thisobj.ProgressionCurve.count] = 0;
					at time 100
						SMStruct.thisobj.ProgressionCurve[SMStruct.thisobj.ProgressionCurve.count] = 1;
					-- make linear:	
					SMStruct.thisobj.ProgressionCurve[SMStruct.thisobj.ProgressionCurve.count].controller.keys[1].outtangenttype = #linear
					SMStruct.thisobj.ProgressionCurve[SMStruct.thisobj.ProgressionCurve.count].controller.keys[2].intangenttype = #linear
				)

			)
			smstruct.rebuilddynamicrollout();
			surfacemorphermain.targlist.columns.item[1].text = surfacemorphermain.targlist.columns.item[1].text
			populatelist clear:true	
		smstruct.updateUI()
		)
	,
		fn updateStack =
		(
			SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
		)
	,
	
	
		fn getSelectedIndices i &channelindex &targetindex =
		(
			local whichItems = surfacemorphermain.targList.selecteditems.item[i-1].tag.value
			if whichItems[1] == #Channel then -- this just uses target 1
			(
				channelindex = whichItems[2];
				targetIndex = 1;
			) else (
			
				channelindex = whichItems[2];
				targetIndex = whichItems[3];
				
			)
			
		)
	,
		fn rebuilddynamicrollout =
		(
			removesubrollout SurfaceMorpherHolder.rollholder surfaceMorpher
			SMStruct.makeDynSurfaceMorphRoll()
			addsubrollout  SurfaceMorpherHolder.rollholder surfaceMorpher
			surfacemorphermain.targlist.columns.item[1].text = surfacemorphermain.targlist.columns.item[1].text
			smstruct.updateUI()

		)

)
SMStruct = surfaceMorphStruct()	

	rollout surfaceMorphvalueChanger "Edit Min/Max" width:211 height:53
	(
		spinner mini "Min" pos:[13,9] width:87 height:16 range:[-100000,1000000,0]
		spinner maxi "Max" pos:[113,9] width:87 height:16 range:[-100000,1000000,1]
		button Reset "Reset" pos:[125,33] width:71 height:18
		button ok "Ok" pos:[12,33] width:71 height:18
		on ok pressed do  (
			smstruct.minval =  mini.value
			smstruct.maxval = maxi.value
			destroydialog surfaceMorphvalueChanger 
		)

		on surfaceMorphvalueChanger open do (
			mini.value = smstruct.minval
			maxi.value = smstruct.maxval
		)
		on surfaceMorphvalueChanger close do (
			smstruct.minval =  mini.value
			smstruct.maxval = maxi.value
		)
		on reset pressed do (mini.value = smstruct.minval; maxi.value = smstruct.maxval)
	)
	SMStruct.surfaceMorphvalueChanger = surfaceMorphvalueChanger 
	rollout surfaceMorphSpinnerChanger "Edit Value" width:211 height:53
	(
		spinner mini "Value" pos:[13,9] width:87 height:16 range:[-100000,1000000,0]
		button Reset "Reset" pos:[125,33] width:71 height:18
		button ok "Ok" pos:[12,33] width:71 height:18
		on ok pressed do  (
			smstruct.progoffset =  mini.value
			destroydialog surfaceMorphSpinnerChanger 
		)
		on surfaceMorphSpinnerChanger open do (
			mini.value = smstruct.progoffset
		)
		on surfaceMorphSpinnerChanger close do (
		--print mini.value
			smstruct.progoffset =  mini.value
		)
		on reset pressed do (mini.value = smstruct.progoffset)
	)
	SMStruct.surfaceMorphSpinnerChanger = surfaceMorphSpinnerChanger 
	rollout SurfaceMorpherGlobals "Globals"
	(
		GroupBox grp1 "Globals" pos:[4,3] width:772 height:68
		spinner refTargMapChan "Reference Map Channel" pos:[18,17] width:148 height:16 range:[0,100,1] type:#integer fieldwidth:20
		spinner stackMapChan "Stack Map Channel" pos:[39,42] width:126 height:16 range:[0,100,1] type:#integer fieldwidth:20
		spinner morphUVdom "UV Dominance" pos:[458,19] width:106 height:16 range:[0,1,0] type:#integer fieldwidth:20
		dropdownList surfaceAlgo "" pos:[281,15] width:164 height:21 items:#("U or V Dominant", "Single Edge", "Auto UV", "Orthagonal UV", "All Edges","Vector Hinted")
	

		label lbl1 "Surface Algorithm:" pos:[187,18] width:90 height:17
		checkbox blurMorph "Blur Morph (experimental)" pos:[183,44] width:156 height:15

		spinner morphblursteps "Blur Steps:" pos:[355,45] width:80 height:16 range:[1,100,5] type:#integer fieldwidth:35
		spinner morphBlurMult "Blur Mult:" pos:[473,44] width:91 height:16 range:[0,1,0.2] type:#float fieldwidth:35
		checkbox doOrtho "Orthogonalize" pos:[567,19] width:90 height:15
		checkbox doDisplay "Show Xfrms" pos:[570,45] height:15
		spinner DisplayScale "Scale:" pos:[650,47] height:16 scale:0.01 range:[0,1000,1] type:#float fieldwidth:35

		spinner whichUp "UpVec" pos:[647,19] width:80 height:16 range:[0,2,1] type:#integer fieldwidth:35
		checkbox doWeightedNorms "WeightedNormals" pos:[570,65] height:15
		on surfaceAlgo selected val do 
		(
			smstruct.thisObj.SurfaceAlgorithm = val-1;
			smstruct.updateglobalui()
			messagebox "You should recache the reference cache" title:"SurfaceMorph";
		)
		
		on doDisplay changed state do
		(
			SMStruct.thisobj.DisplayReferenceTransforms = if state then 1 else 0;
		)
		on displayscale changed val do
		(
			SMStruct.thisobj.DisplayReferenceTransformsScale = val
		)
		on doWeightedNorms changed val do
		(
			if (val == true) then
				SMStruct.thisobj.DoWeightedNorms = 1
			else SMStruct.thisobj.DoWeightedNorms = 0
		)
		on refTargMapChan changed val do SMStruct.thisobj.ReferenceMapChannel = val;
		on stackMapChan changed val do SMStruct.thisobj.StackMapChannel= val;
		on morphUVdom changed val do SMStruct.thisobj.MorphUVDominance= val;
		on blurMorph changed val do SMStruct.thisobj.DoMorphBlur= if val then 1 else 0;
		on morphblursteps changed val do SMStruct.thisobj.MorphBlurSteps= val;
		on morphBlurMult changed val do SMStruct.thisobj.MorphBlurMult= val;
		on doOrtho changed val do 
		(
			SMStruct.thisobj.Orthogonalize= if val then 1 else 0;
			messagebox "You should recache the reference cache" title:"SurfaceMorph";
		)
		on whichUp changed val do
		(
			SMStruct.thisobj.upvector= val
			messagebox "You should recache the reference cache" title:"SurfaceMorph";
		)

	)
	SMStruct.SurfaceMorpherGlobals = SurfaceMorpherGlobals 
rollout SurfaceMorpherMain "Surface Morpher Controls" width:400 height:692
(
	local minval, maxval;
	local copyPaintMaskFromValue;
	dotNetControl targlist "ListView" pos:[2,10] width:479 height:364
	checkbutton addNew "Add Channel" pos:[3,383] width:77 height:25
	button AddChannels "Add Channels" pos:[5,412] width:77 height:25
	checkbutton AddProgressiveTarget "Add Progressive Target" pos:[83,383] width:119 height:25
	button AddProgressiveTargets "Add Prog. Targets" pos:[83,411] width:119 height:25
	button remove "Delete" pos:[208,410] width:62 height:25
	button insert "Insert" pos:[80,442] width:41 height:25 enabled:false
	button up "Up" pos:[120,441] width:24 height:25 enabled:false
	button down "Dn" pos:[145,435] width:24 height:25 enabled:false
	checkbutton pickreference "PickReference" pos:[281,399] width:84 height:25
	button unpickRef "Unpick Reference" pos:[365,427] width:117 height:25
	checkbox recacheSel "Recache Selection if recaching" pos:[283,455] width:196 height:15
	checkbox lockCaching "Lock Caching" pos:[394,472] width:90 height:16
	checkbox cacheref "Cache Reference" pos:[283,472] width:106 height:15
	button UpdateRef "Update Cache" pos:[278,427] width:84 height:25
	label refName "" pos:[372,401] width:103 height:19
	button ExtractTopModifier "Extract Stack as Target" pos:[6,469] width:157 height:25
	button ExtractTarget "Extract Target(s)" pos:[165,469] width:106 height:25
	checkbutton replaceTarget "Replace" pos:[208,383] width:62 height:25
	
	GroupBox grp6 "Reference Options:" pos:[276,383] width:209 height:111
	GroupBox grp1 "Channel Settings" pos:[487,4] width:232 height:379
	GroupBox grp2 "Target Settings:" pos:[487,383] width:232 height:111
	GroupBox grp3 "Morph Masks:" pos:[490,116] width:225 height:142
	GroupBox grp5 "Progressive Settings:" pos:[489,261] width:225 height:119
	
	checkbox dodebug "Debug On" pos:[174,444] width:92 height:18
	button addpc2 "Add .PC2" pos:[5,440] width:77 height:25


	dropdownList morphtype "Morph Type:" pos:[493,17] width:108 height:40 enabled:false items:#("Local (Morpher)", "Surface")
	spinner rangemin "Min:" pos:[503,61] width:67 height:16 range:[-10000,10000,0] fieldwidth:35
	spinner rangemax "Max:" pos:[611,62] width:70 height:16 range:[-10000,10000,0] fieldwidth:35
	checkbox usePaintMask "Use Paint Mask" pos:[493,399] width:101 height:18
	checkbox invertPaintMask "Invert" pos:[657,395] width:50 height:18
	spinner progoffset "Prog. Offset:" pos:[500,422] width:100 height:16 range:[-100,100,0] fieldwidth:35 visible:false
	spinner targetMultiplier "Multiplier:" pos:[615,423] width:86 height:16 range:[0,100,0] fieldwidth:35
	button copyPaintMask "Copy Paint Mask..." pos:[493,466] width:101 height:20
	checkbox useTargSelection "Mask By Target Selection" pos:[495,150] width:146 height:18
	checkbox invertTargSelection "Invert" pos:[663,149] width:50 height:18
	checkbox useReferenceSelection "Mask By Reference Selection" pos:[495,169] width:163 height:18
	checkbox useStackSelection "Mask By Stack Selection" pos:[495,131] width:146 height:18
	checkbox invertRefSelection "Invert" pos:[663,168] width:50 height:18
	checkbox recacheSelection "Recache Selection if recaching" pos:[496,234] width:181 height:18
	checkbox useMap "Mask by Tension (Map):" pos:[495,189] width:138 height:18
	button recacheNow "Recache Now" pos:[493,444] width:101 height:20
	spinner useMapChannel "Map:" pos:[504,213] width:71 height:16 range:[-2,100,0] type:#integer fieldwidth:35
	dropdownList usemapRGB "" pos:[595,209] width:55 height:21 items:#("Red", "Green", "Blue", "Luma")
	dropdownList MorphMode "Morph Mode:" pos:[603,15] width:108 height:40 items:#("Morph on Base", "Cumulative - on morph stack")
	--checkbox doInterpolate "Interpolate" pos:[496,243] width:72 height:17
	dropdownList interpolationAlgorithm "" pos:[597,276] width:108 height:21 items:#("Linear", "Bezier", "Hermite")
	label lbl2 "Algorithm:" pos:[498,279] width:52 height:16
	spinner hermiteTension "Tension:" pos:[503,302] width:100 height:16 range:[-100,100,0] fieldwidth:35
	spinner hermiteBias "Bias:" pos:[618,303] width:86 height:16 range:[-100,100,0] fieldwidth:35
	checkbox maskInterpToBase "Mask to Base (otherwise previous target)" pos:[495,320] width:210 height:18
	checkbox clampMapMask "Clamp" pos:[663,210] width:50 height:18
	checkbox invertMapMask "Invert" pos:[663,189] width:50 height:18
	dropdownList LocalMorphMode "Local Morph Mode:" pos:[599,445] width:108 height:40 items:#("Set by Channel", "Morph", "Cumulative")
	GroupBox grp6a "Point Cache (PC2)" pos:[3,496] width:716 height:58
	button pickPC2 "Pick New PC2..." pos:[589,530] width:85 height:20 enabled:true
	button reloadPC2 "Reload" pos:[676,530] width:40 height:20 enabled:true
	checkbox usepc2 "Use PC2 for Target" pos:[15,512] width:120 height:18
	checkbox preloadpc2 "Preload entire cache" pos:[145,512] width:120 height:18
	checkbox maskpc2throughprogression "Mask through progression" pos:[275,512] width:148 height:18
	edittext pc2filename "" pos:[9,531] width:577 height:16
	dropdownList ProgressionOutOfRangeHandling "" pos:[593,344] width:116 height:21 items:#("Clamp", "Cycle", "Ping Pong")
	dropdownList WeightOutOfRangeHandling "" pos:[593,91] width:116 height:21 items:#("Do Nothing (overshoot)", "Cycle", "Ping Pong", "Scale By Range", "Clamp 0-1")
	label lbl3 "OOR Progression:" pos:[498,348] width:87 height:14
	label lbl4 "OOR Weight:" pos:[499,95] width:87 height:14
	fn disableChannelUI =
	(
		for i in 27 to SurfaceMorpherMain.controls.count do
		(
			SurfaceMorpherMain.controls[i].enabled = false;
		)
	)	
	on ProgressionOutOfRangeHandling selected val do (
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.OutOfRangeProgressionHandling[channelindex] = val - 1
		)
		smstruct.updateStack()
	)
	on WeightOutOfRangeHandling selected val do (
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.OutOfRangeWeightHandling[channelindex] = val - 1
		)
		smstruct.updateStack()
	)
	on pickPC2 pressed do
	(
		pfile = getopenfilename types:"Point Cache(*.PC2)|*.pc2" filename:(if pc2filename.text != undefined then pc2filename.text else "") caption:"Pick Pointcache file (PC2)"
		if pfile != undefined do
		(
			pc2filename.text = pfile
			pc2filename.entered pfile;
			
		)
	)
	on reloadPC2 pressed do
	(
		if pc2filename.text != undefined do
		(
			pc2filename.entered pc2filename.text; -- this forces a reload
			
		)
	)
	on usepc2 changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.SetUsePC2 channelindex  targetIndex  (if state then 1 else 0)
		)
		smstruct.updateStack()
	)
	on preloadpc2 changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.SetDoPreloadPC2 channelindex   targetIndex  (if state then 1 else 0)
		)
		smstruct.updateStack()
	)
	on maskpc2throughprogression  changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.SetMaskThroughProg channelindex (if state then 1 else 0)
		)
		smstruct.updateStack()
	)
	on pc2filename entered val do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.SetPC2filename channelindex  targetIndex val
		)
		smstruct.updateStack()
	)
	on addpc2 pressed do
	(
		pc2file = getopenfilename()
		if pc2file != undefined do
		(
			-- add a new channel:
			smstruct.addPC2Channel pc2file;
			smstruct.updateChannelUI()
		)
		
	)
	on copyPaintMask pressed do
	(
		if targList.selecteditems.count != 1 do 
		(
			Messagebox "Select just one target/channel to copy from" title:"Surface Morph"
			return();
			
		)
		copyPaintMaskFromValue = targList.selecteditems.item[0].tag.value
		
	)
	on reCacheNow pressed do
	(
		for i in 1 to targList.selecteditems.count do
		(
			whichItems = targList.selecteditems.item[i-1].tag.value
			if whichItems[1] == #Channel do whichItems[3] = 1 -- fill in default value
			--print (SMStruct.thisobj.GetCacheMe whichItems[2] whichItems[3] )
			if SMStruct.thisobj.GetCacheMe whichItems[2] whichItems[3] == 1 do
			(
				SMStruct.thisobj.SetCacheMe whichItems[2] whichItems[3] 0
				smstruct.updateStack()
				forcecompleteredraw()
				SMStruct.thisobj.SetCacheMe whichItems[2] whichItems[3] 1
			
			)
		)
	)
	on hermitetension changed val do
	(
		for i in 1 to targList.selecteditems.count do
		(
			whichItems = targList.selecteditems.item[i-1].tag.value
			if whichItems[1] == #Channel then
			(
				SMStruct.thisobj.SetHermiteTension whichItems[2] val
			)
		)
		smstruct.updateStack()
	)
	on hermiteBias changed val do
	(
		for i in 1 to targList.selecteditems.count do
		(
			whichItems = targList.selecteditems.item[i-1].tag.value
			if whichItems[1] == #Channel then
			(
				SMStruct.thisobj.SetHermiteBias whichItems[2] val
			)
		)
		smstruct.updateStack()
	)
	on rangemin changed val do
	(
		for i in 1 to targList.selecteditems.count do
		(
			whichItems = targList.selecteditems.item[i-1].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2] as integer;
			) else return()		
			SMStruct.thisobj.minrange[channelindex] = val
			targList.selecteditems.item[i-1].subitems.item[2].text = val as string
		)
		smstruct.updateStack()
	)
	on rangemin entered do
	(
		val = rangemin.value
		for i in 1 to targList.selecteditems.count do
		(
			whichItems = targList.selecteditems.item[i-1].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2] as integer;
			) else return()		
			SMStruct.thisobj.minrange[channelindex] = val
			targList.selecteditems.item[i-1].subitems.item[2].text = val as string
		)
		smstruct.rebuilddynamicrollout()
		smstruct.updateStack()
	)

	
	on rangemax changed val do
	(
		for i in 1 to targList.selecteditems.count do
		(
			whichItems = targList.selecteditems.item[i-1].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2] as integer;
			) else return()
			SMStruct.thisobj.maxrange[channelindex] = val
			targList.selecteditems.item[i-1].subitems.item[3].text = val as string
		)
		smstruct.updateStack()
	)
	on rangemax entered do
	(
		val = rangemax.value
		for i in 1 to targList.selecteditems.count do
		(
			whichItems = targList.selecteditems.item[i-1].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2] as integer;
			) else return()
			SMStruct.thisobj.maxrange[channelindex] = val
			targList.selecteditems.item[i-1].subitems.item[3].text = val as string
		)
		smstruct.rebuilddynamicrollout()
		smstruct.updateStack()
	)
		
	on MorphMode selected val do (
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.MorphMode[channelindex] = val - 1
		)
		smstruct.updateStack()
	)
	on morphType selected val do (
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.MorphType[channelindex] = val - 1
		)
		smstruct.updateStack()
	)
	on localmorphmode selected val do (
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.SetLocalMorphMode channelindex targetindex (val - 2)
		)
		smstruct.updateStack()
	)
	on targetMultiplier changed val do (
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.SetProgTargetMultiplier channelindex targetindex val
		)
		smstruct.updateStack()
	)
	on progoffset changed val do(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.SetProgTargetOffset channelindex targetindex val
		)
		smstruct.updateStack()
	)
	on maskInterpToBase changed state do
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.MaskTargetToBase [channelindex ] = if state then 1 else 0;
		)
	on doInterpolate changed state do
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.UseInterpolation[channelindex ] = if state then 1 else 0;
		)
	on interpolationAlgorithm selected val do
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			
			SMStruct.thisobj.InterpolationType[channelindex ] = val - 1; -- offset is 2 since we  have linear in the list
			if val == 3 then
				surfacemorphermain.hermiteTension.enabled = surfacemorphermain.hermiteBias.enabled = true;
			else 
				surfacemorphermain.hermiteTension.enabled = surfacemorphermain.hermiteBias.enabled = false;
		
		)
	on recacheSelection changed state do
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.ReCacheSelectionEnable[channelindex ] = if state then 1 else 0;
		)
	on clampMapMask changed state do
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.clampMap[channelindex ] = if state then 1 else 0;
		)
	on useMapChannel changed val do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.WhichMap[channelindex]= val
		)
		smstruct.updateStack()
		--smstruct.populatelist clear:true
	)
	on usemapRGB selected sel do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			SMStruct.thisobj.WhichChannel[channelindex]= sel - 1
		)
		smstruct.updateStack()
		--smstruct.populatelist clear:true
	)
	on useMap changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if state then (
				if invertMapMask .state then
					SMStruct.thisobj.UseMap[channelindex]= -1
				else 
					SMStruct.thisobj.UseMap[channelindex]= 1
			)
			else SMStruct.thisobj.UseMap[channelindex] = 0
		)
		smstruct.updateStack()
		--smstruct.populatelist clear:true
	)
	on invertMapMask changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if SMStruct.thisobj.UseMap[channelindex] != 0 then 
				if SMStruct.thisobj.UseMap[channelindex] == 1 then
					SMStruct.thisobj.UseMap[channelindex] = -1
				else
					SMStruct.thisobj.UseMap[channelindex] = 1
			else invertMapMask.state = false;
		)
		smstruct.updateStack()
	)
	on useReferenceSelection changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if state then (
				if invertRefSelection.state then
					SMStruct.thisobj.usereferenceselection[channelindex]= -1
				else 
					SMStruct.thisobj.usereferenceselection[channelindex]= 1
			)
			else SMStruct.thisobj.usereferenceselection[channelindex] = 0
		)
		smstruct.updateStack()
		--smstruct.populatelist clear:true
	)
	on invertRefSelection changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if SMStruct.thisobj.usereferenceselection[channelindex] != 0 then 
				if SMStruct.thisobj.usereferenceselection[channelindex] == 1 then
					SMStruct.thisobj.usereferenceselection[channelindex] = -1
				else
					SMStruct.thisobj.usereferenceselection[channelindex] = 1
			else invertRefSelection.state = false;
		)
		smstruct.updateStack()
	)

	on useTargSelection changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if state then (
				if invertTargSelection.state then
					SMStruct.thisobj.useTargetSelection[channelindex]= -1
				else 
					SMStruct.thisobj.useTargetSelection[channelindex]= 1
			)
			else SMStruct.thisobj.useTargetSelection[channelindex] = 0
		)
		smstruct.updateStack()
		--smstruct.populatelist clear:true
	)
	on useStackSelection changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if state then (
				--if invertTargSelection.state then
				--	SMStruct.thisobj.useStackSelection[channelindex]= -1
				--else 
					SMStruct.thisobj.useStackSelection[channelindex]= 1
			)
			else SMStruct.thisobj.useStackSelection[channelindex] = 0
		)
		smstruct.updateStack()
		--smstruct.populatelist clear:true
	)
	on invertTargSelection changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if SMStruct.thisobj.useTargetSelection[channelindex] != 0 then 
				if SMStruct.thisobj.useTargetSelection[channelindex] == 1 then
					SMStruct.thisobj.useTargetSelection[channelindex] = -1
				else
					SMStruct.thisobj.useTargetSelection[channelindex] = 1
			else invertTargSelection.state = false;
		)
		smstruct.updateStack()
	)
	on invertPaintMask changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if (SMStruct.thisobj.GetLocalUsePaint channelindex targetIndex) != 0 then 
				if (SMStruct.thisobj.GetLocalUsePaint channelindex targetIndex) == 1 then
					(SMStruct.thisobj.SetLocalUsePaint channelindex targetIndex -1)
				else
					(SMStruct.thisobj.SetLocalUsePaint channelindex targetIndex 1)
			else invertPaintMask.state = false;
		)
		smstruct.updateStack()
	)
	on usePaintMask changed state do
	(
		for i in 1 to surfacemorphermain.targlist.selecteditems.count do
		(
			channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
			if state then (
				if invertPaintMask.state then
					(SMStruct.thisobj.SetLocalUsePaint channelindex targetIndex -1)
				else 
					(SMStruct.thisobj.SetLocalUsePaint channelindex targetIndex 1)
			)
			else (SMStruct.thisobj.SetLocalUsePaint channelindex targetIndex 0)
		)
		smstruct.updateStack()
	)


	fn enableChannelUI =
	(
		for i in 25 to SurfaceMorpherMain.controls.count do
		(
			SurfaceMorpherMain.controls[i].enabled = true;
		)
	)

		on unpickRef pressed do (
			SMStruct.thisobj.ReferenceObject = undefined;
			SMStruct.thisobj.ResetUndefCache();
			refName.caption = "Captured from Stack"
			
		)
		on replaceTarget changed state do
		(
			--if PaintSelected.state do return(togglepaintchannel.state = false);
			selcount = surfacemorphermain.targlist.selecteditems.count;
			if selcount < 1 do return(replaceTarget.state = false);
			whichItems = targList.selecteditems.item[0].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2] as integer;
				targetIndex = 1;
			) else (
			
				channelindex = whichItems[2] as integer;
				targetIndex = whichItems[3] as integer;
				
			)
--show smstruct.thisNode
			local objs = pickObject message:"Pick Target" count:1 select:false forceListenerFocus:false
			if objs == undefined do return()


			if state == true then
			(
				SMStruct.thisobj.replacemorphtarget objs channelindex targetindex
			)else(
			)
			replaceTarget.state = false
			SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
		
		)
		on remove pressed do
		(
			selcount = surfacemorphermain.targlist.selecteditems.count;
			--print selcount
			for i in selcount to 1 by -1 do
			(
				whichItems = targList.selecteditems.item[i-1].tag.value
				if whichItems[1] == #Channel then
				(
					channelindex = whichItems[2];
					targetIndex = 1;
					SMStruct.thisobj.DeleteChannel channelindex;
					-- remove pblock items
					deleteitem SMStruct.thisobj.EnabledList channelindex
					deleteitem SMStruct.thisobj.WeightList channelindex
					deleteitem SMStruct.thisobj.CachedList channelindex
					deleteitem SMStruct.thisobj.MorphType channelindex
					deleteitem SMStruct.thisobj.UVDominance channelindex	
					deleteitem SMStruct.thisobj.MinRange channelindex	
					deleteitem SMStruct.thisobj.MaxRange channelindex	
					deleteitem SMStruct.thisobj.UseTargetSelection channelindex	
					deleteitem SMStruct.thisobj.UseReferenceSelection channelindex	
					deleteitem SMStruct.thisobj.ReCacheSelectionEnable channelindex	
					deleteitem SMStruct.thisobj.UseMap channelindex	
					deleteitem SMStruct.thisobj.clampMap channelindex	
					deleteitem SMStruct.thisobj.WhichMap channelindex	
					deleteitem SMStruct.thisobj.WhichChannel channelindex	
					
				--	append SMStruct.thisobj.TargetNames i.name; -- this needs to be removed from the pblock...
					deleteitem SMStruct.thisobj.MorphMode channelindex;
					deleteitem SMStruct.thisobj.MapChannel channelindex;
					deleteitem SMStruct.thisobj.UseInterpolation channelindex;
					deleteitem SMStruct.thisobj.InterpolationType channelindex;
					deleteitem SMStruct.thisobj.MaskTargetToBase channelindex;
					deleteitem SMStruct.thisobj.ProgressionCurve channelindex
					deleteitem SMStruct.thisobj.OutOfRangeProgressionHandling channelindex
					deleteitem SMStruct.thisobj.OutOfRangeWeightHandling channelindex

				) else (
				
					channelindex = whichItems[2];
					targetIndex = whichItems[3];
					SMStruct.thisobj.DeleteTarget channelindex targetindex;
				)
			)
			smstruct.populatelist clear:true;
			--smstruct.updateGlobalUI()
			--SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
		)
		--timer tt active:true interval:100

		on doDebug changed val do SMStruct.thisobj.debugOn = if val then 1 else 0;
		--on doInterp changed val do SMStruct.thisobj.InterpProgressive = if val then 1 else 0;
		on lockCaching changed val do SMStruct.thisobj.lockCaching = if val == true then 1 else 0;
		on mode selected val do SMStruct.thisobj.mode = val-1;
		on updateRef pressed do
		(
			SMStruct.thisobj.ResetUndefCache();
		)
		
		
		on targList keyUp event do
		(	
			--print event.keyCode.value__
			--snapMode.setOSnapItemActive 2 1 false
			--print event.keycode.F2.value__
			--show event
			--show event.keycode
			local f5val = event.keycode.F5.value__
			local f2val = event.keycode.F2.value__
			local F3val = event.keycode.F3.value__
			local Enterval = event.keycode.Enter.value__
			local shiftval = event.keycode.shift.value__
			local Controlval = event.keycode.Control.value__
			local Altval = event.keycode.Alt.value__
			local Aval = event.keycode.A.value__
			case event.keyCode.value__ of
			(
				f2val: (
					try(
						targlist.labeledit = true;
						targList.selecteditems.item[0].beginedit()
					)catch()
				)
			)
		)

		on targList keyDown event do
		(	
			--print event.keyCode.value__
			--snapMode.setOSnapItemActive 2 1 true
			
		)

		
		on ExtractTopModifier pressed do
		(
			nodeme = smstruct.thisNode
			if nodeme.modifiers.count == 0 do return();
			nodetarget = copy nodeme
			deletemodifier nodetarget 1
			collapsestack nodetarget
			if smstruct.thisobj.referenceobject != undefined then
				nodereference = copy smstruct.thisobj.referenceobject
			else 
				nodereference = copy smstruct.thisnode
			collapsestack nodereference
			
			nodeme.modifiers[1].enabled = false
			SMStruct.thisobj.buildtarget nodeme nodetarget nodereference 
			delete nodetarget;
		)
		on ExtractTarget pressed do
		(
			if targlist.selecteditems.count == 0 do return();
			for i in 1 to targlist.selecteditems.count do
			(
				channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices i &channelindex &targetindex;
				nodeme = smstruct.thisNode
				if nodeme.modifiers.count == 0 do return();
				nodetarget = copy nodeme
				collapsestack nodetarget
				nodetarget.name += "_SMExtracted"
				SMStruct.thisobj.extracttarget nodetarget channelindex targetindex
			)
		)
		on recacheSel changed val do
		(
			SMStruct.thisobj.ReCacheReferenceSelection = val;
		)
		on cacheRef changed val do
		(
			SMStruct.thisobj.CacheReference = val;
		)
		on targList afterlabeledit e do
		(
			show e
		 	NewString = e.label
		 	if newstring == undefined do return()
			whichitem = 0;
			whichtarget = 0;
			whichItems = targList.selecteditems.item[0].tag.value
			if whichItems[1] == #Channel then
			(
				SMStruct.thisobj.setchannelname whichitems[2] newstring;
			)
			else (
				whichitem = whichitems[2]
				whichTarget =  whichitems[3] 
				SMStruct.thisobj.SetTargetName whichitem whichTarget newstring;
				)
			targlist.labeledit = false;
		)
		

		on SurfaceMorpherMain open do
		(
			smstruct.updateGlobalUI()
			smstruct.updateChannelUI()
		)
		on SurfaceMorpherMain close do
		(
			if SMStruct.paintingDidTakePlace == true do 
				try(SMStruct.thisobj.endPaint())catch()
			if smstruct.wasShowVertexOn == false do
				try(smstruct.thisNode.showVertexColors = false)catch()
		
		)
		on pickreference changed state do
		(
			if state then(
				local obj = pickObject count:1 select:true
				if obj == undefined do return(pickreference.state = false)
				SMStruct.thisobj.ReferenceObject = obj
				refName.caption = obj.name
				pickreference.state = false
			) else max move 
		)
		fn mrph_filt obj = obj != smstruct.thisnode
		on addNew changed state do
		(
			if state == false do
			(
				max move
			)
			local origc = targlist.items.count;
			local objs = pickObject message:"Pick a Target" prompt:"Pick Morph" count:1 select:false forceListenerFocus:false
			if objs == undefined do return(addnew.state = false)
			smstruct.addChannels objs;
			if targList.items.count == 0 OR targList.items.count == origc  do return(surfacemorphermain.addNew.state = false);
			targList.multiselect = false
			targList.items.item[targlist.items.count - 1].selected = true;
			targList.multiselect = true
			surfacemorphermain.addNew.state = false
			smstruct.updateChannelUI()
			
		)
		on addchannels pressed do -- this is a selection list based one
		(
			local objs = selectbyname title:"Pick Morph Targets" showHidden:true single:false filter:mrph_filt
			if objs == undefined do return()
			smstruct.addChannels objs;
			smstruct.updateChannelUI()
			
		)
		
		on AddProgressiveTarget changed state do
		(


			if targList.selecteditems.count < 1 do(
				AddProgressiveTarget.state = false
				return (messagebox "Must select a channel");
			)


			local objs = pickObject message:"Pick a Target" prompt:"Pick Progressive Target" count:1 select:false forceListenerFocus:false
			if objs == undefined do return()
			
			for j in 1 to targList.selecteditems.count do
			(
				channelindex = 1;targetIndex = 1;smstruct.getSelectedIndices j &channelindex &targetindex;
				for i in objs do
					SMStruct.thisobj.AddMorphTarget i channelindex --(SMStruct.thisobj.GetChannelCount() + 1);
				AddProgressiveTarget.state = false
			)
			--populatelist clear:true
			smstruct.rebuilddynamicrollout();
			targlist.columns.item[1].text = targlist.columns.item[1].text -- update columns that keep disappearing
			smstruct.populatelist clear:true
		)
		on AddProgressiveTargets pressed do -- this is a selection list based one
		(


			if targList.selecteditems.count < 1 do(
				AddProgressiveTarget.state = false
				return (messagebox "Must select a channel" title:"SurfaceMorph");
			)


			local objs = selectbyname title:"Pick Morph Targets" showHidden:true single:false filter:mrph_filt
			if objs == undefined do return()



			whichSelected = targList.selecteditems.item[0].index + 1

			whichitem = 0;
			whichtarget = 0;

			whichItems = targList.selecteditems.item[0].tag.value
			if whichItems[1] == #Channel then
			channelindex = whichItems[2];


			--print channelindex ;
			for i in objs do
			(
				SMStruct.thisobj.AddMorphTarget i channelindex
			)
			AddProgressiveTarget.state = false
			--populatelist clear:true
			
			smstruct.rebuilddynamicrollout();

			targlist.columns.item[1].text = targlist.columns.item[1].text
			smstruct.populatelist clear:true
			smstruct.updateChannelUI()
			
		)			
		fn initTargetList =
		(
			local size1
			targlist.gridlines = true;
			targlist.multiselect = true
			targlist.checkboxes = true;
			targlist.fullRowSelect = true;
			targlist.hideselection = false;
			targlist.labeledit = false;
			tview = dotnetclass "System.Windows.Forms.View"
			targlist.view = tview.details
			targlist.columns.add "On/Name" 182
			targlist.columns.add "Cache" 45
			--targlist.columns.add "Type" 50
			--targlist.columns.add "UV" 30
			targlist.columns.add "Min" 35
			targlist.columns.add "Max" 35
			targlist.columns.add "TSel" 50
			--targlist.columns.add "Rsel" 35
			--targlist.columns.add "ReCS" 45
			targlist.columns.add "Tension" 50
			--targlist.columns.add "Map" 35
			--targlist.columns.add "RGB" 35
			--targlist.columns.add "Mode" 40
			--targlist.columns.add "Chan" 40
			--targlist.columns.add "clampMap" 50
			--targlist.columns.add "Interp" 50
			--targlist.columns.add "Type" 50
			--targlist.columns.add "MBase" 50
			targlist.columns.add "UsePaint" 60
		--	show a
			targlist.columns.item[1].text = targlist.columns.item[1].text
			smstruct.populatelist();
		)
		
	function getListSelectionIndices input =
	(
		if input.items == undefined do return(#())
		local selArr = #()
		for i in 1 to input.items.count do
			if input.items.item[i-1].selected do append selArr (input.items.item[i-1].index + 1)
		return selArr
	)
	function getHitNodeCells input x: y: =
	(
		local lineValue = 15
		if x == unsupplied OR y == unsupplied then
			p = getCursorPos input
		else p = [x,y]
		hitnode = listview.hitTest input.hwnd [p.x,p.y]
		--print (hitnode = listview.hitTest input.hwnd [(p.x*lineValue),((p.y - 1)*lineValue )]  )
		--if hitnode == undefined do hitnode = input.hitTest (p.x*lineValue) ((p.y - 2)*lineValue)
		return hitnode
	)
	fn dotNETGetHitNode inputdialog inputax x: y: which:#item =
	(
		if x == unsupplied do 
		(
			local allpos = getdialogpos inputdialog
			local axpos = 2 * inputax.pos
			mpos = inputax.mouseposition
			nx = mpos.x - allpos.x - axpos.x
			ny = mpos.y - allpos.y - axpos.y + 2
		)
		if x == unsupplied do 
		(
			x = nx
			y = ny
		)
		--print "--"
		--print [x,y]
		--hitnode = input.hitTest (p.x*lineValue) ((p.y - 1)*lineValue )
		hitnode = inputax.hitTest x y
		if hitnode.item == undefined do return(undefined)-- hitnode = input.hitTest (p.x*lineValue) ((p.y - 2)*lineValue)
		--print hitnode.item.text
		--print hitnode.subitem.text
		--print x
		try(x -= inputax.items.item[0].bounds.x)catch() -- for scrolling:
		case which of
		(
			default: return (hitnode.item)
			#cell: (
				-- find which cell:
				local whichcolumn
				local widthSum = 0
				for i in 1 to hitnode.item.subitems.count do
				(
					--print 
					widthSum += inputax.columns.item[i-1].width;
				--	print widthSum
					if widthsum > x do
					(
						whichcolumn = i-1
						return #( whichcolumn, hitnode.item.index+1); -- no more to do
					)
					whichcolumn = i - 1; -- so the last item is catered for
					--if hitnode.subitem.text != undefined do
					--	if hitnode.subitem.text == hitnode.item.subitems.item[i-1].text do whichcolumn = i-1
				)
				return #( whichcolumn, hitnode.item.index+1);
			)
		)
		
	)
	fn dotNETgetbutton event =
	(
		if (event.button.value__) == (event.button.left.value__) then
			return 1
		else if  (event.button.value__) == (event.button.middle.value__) then
			return 4
		else if  (event.button.value__) == (event.button.right.value__) then
			return 2
	)

	function getNETColor hColor = --New function
	(
		local dnColor = dotNetClass "System.Drawing.Color"
		dnColor.fromARGB hColor.r hColor.g hColor.b
	)

	on targList itemcheck Item do
	(
		--try(
		--print 	smstruct.mouseIsDown
		if 	smstruct.mouseIsDown == true do (
			smstruct.mouseIsDown = false
			print "eed"
			whichitem = 0;
			whichtarget = 0;
			whichItems = targList.items.item[item.index].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2];
				SMStruct.thisobj.enabledlist[channelindex] = Item.NewValue.value__
			)  else (
				channelindex = whichItems[2];
				targetindex = whichItems[3];
				SMStruct.thisobj.SetisEnabled channelindex targetIndex Item.NewValue.value__
			)
			smstruct.updateStack()

			smstruct.rebuilddynamicrollout();
			surfacemorphermain.targlist.columns.item[1].text = surfacemorphermain.targlist.columns.item[1].text
			numprogs = (SMStruct.thisobj.GetProgTargetCount channelindex );
			if 	whichItems[1] == #channel AND numprogs > 1 do
			(
				--print "yerew"
				-- clear this channels subitems:
				for n in 1 to numprogs do
				(
					if SMStruct.thisobj.enabledlist[channelindex] == 0 then
						smstruct.surfacemorphermain.targlist.items.remove targList.items.item[item.index+1]
					else (
						local lisS = surfacemorphermain.targlist.items.insert  (item.index+n) ((SMStruct.thisobj.GetTargetName channelindex  n) +" : " + (SMStruct.thisobj.GetTargetNodeName channelindex  n))
						lisS.checked = 	if SMStruct.thisobj.GetisEnabled channelindex  n == 1 then true else false
						lisS.tag = dotNetMXSValue #(#Target, channelindex , n)
						lisS.imageindex = 2;
						lisS.indentcount = 1
						li = lisS.subitems.add ""
						li.text = if SMStruct.thisobj.GetCacheMe channelindex n == 0 then "false" else "true"
						
						li = lisS.subitems.add ""
						li = lisS.subitems.add ""
						li = lisS.subitems.add ""
						li = lisS.subitems.add ""
						li = lisS.subitems.add (if (SMStruct.thisobj.GetLocalUsePaint channelindex n) == 1 then "true" else "false")
					)
				)
				--SMStruct.populatelist clear:true
			)
			smstruct.mouseIsDown =false
		)

		--)catch()
	)
	on targlist doubleclick event do
	(
		print "dclick"
	)
	on targlist mousedown event do
	(
		--show event
		--print event.tag
		local whichCells  = dotNETGetHitNode SurfaceMorpherMain targList x:event.x y:event.y which:#cell
		local whichCells  = dotNETGetHitNode SurfaceMorpherMain targList x:event.x y:event.y which:#cell
		if whichcells == undefined do return();
		smstruct.mouseIsDown = true;
		whichColumn = whichCells[1] - 0;
		whichCell = whichCells[2] - 1 ;
		--print (whichCells )
		button = dotNETgetButton event;
		--	print button
		if whichCells != undefined do
		(
			whichitem = 0;
			whichtarget = 0;
			whichItems = targList.items.item[whichCell].tag.value
			if whichItems[1] == #Channel then
			(
				if SMStruct.SurfaceMorpherPaint.PaintSelected.state do
				(	
					channelindex = whichItems[2];
					SMStruct.thisobj.endpaint();
					SMStruct.thisobj.StartPaint channelindex 1 SMStruct.thisnode 
					SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
				)
				if SMStruct.SurfaceMorpherPaint.togglepaintchannel .state do
				(	
					channelindex = whichItems[2];
					smstruct.thisobj.SetPaintTempDisplay channelindex 1 1

					SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint; -- just an update forcer
				)
			) else (
				if SMStruct.SurfaceMorpherPaint.PaintSelected.state do
				(	
					channelindex = whichItems[2];
					targetindex = whichItems[3];
					SMStruct.thisobj.endpaint();
					SMStruct.thisobj.StartPaint channelindex targetIndex SMStruct.thisnode -- this automatically cancels if it is on
					SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
				)
				if SMStruct.SurfaceMorpherPaint.togglepaintchannel.state do
				(	
					channelindex = whichItems[2];
					targetindex = whichItems[3];
					smstruct.thisobj.SetPaintTempDisplay channelindex targetIndex  1

					SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
				)
			)
		)
	)
	on targList mouseup event do
	(
		--print "mouseup"
		--smstruct.mouseIsDown = false;
		local listSel = getListSelectionIndices targList

		local whichCells  = dotNETGetHitNode SurfaceMorpherMain targList x:event.x y:event.y which:#cell
		--print #(whichCells)
		if whichcells == undefined do return();
		whichColumn = whichCells[1] - 0;
		whichCell = whichCells[2] - 1 ;
		button = dotNETgetButton event;
		if button == 2 AND whichCells   != undefined AND whichCells[1] == 0 do
		(
			popupmenu SurfaceMorphRCMenu;
		)
		if button == 2 AND whichCells   != undefined AND whichCells[1] > 0 AND whichCells[2] > 0 do
		(
			whichitem = 0;
			whichtarget = 0;
			whichItems = targList.items.item[whichCell].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2];
				val = targList.items.item[whichCell].subitems.item[whichColumn].text
				
				
				case whichColumn of
				(
					1:(
						if val == "true" then
						(	
							targList.items.item[whichCell].subitems.item[whichColumn].text = "false";
							targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor blue;
						)
						else if val == "false" then
						(	
							targList.items.item[whichCell].subitems.item[whichColumn].text = "true";
							targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor red;
						)
						SMStruct.thisobj.SetCacheMe channelindex 1 (if SMStruct.thisobj.GetCacheMe channelindex 1 == 1 then  0 else 1)
						smstruct.updateStack()					
					)
					2:(
						/*
						smstruct.minval=SMStruct.thisobj.minrange[channelindex ]
						smstruct.maxval=SMStruct.thisobj.maxrange[channelindex ]
						createdialog SMStruct.surfaceMorphvalueChanger modal:true
						SMStruct.thisobj.minrange[channelindex ] = smstruct.minval;
						SMStruct.thisobj.maxrange[channelindex ] = smstruct.maxval;
						targList.items.item[whichCell].subitems.item[2].text = smstruct.minval as string
						targList.items.item[whichCell].subitems.item[3].text = smstruct.maxval as string
						
						try(removesubrollout SMStruct.SurfaceMorpherHolder.rollholder surfaceMorpher)catch()
						smstruct.makeDynSurfaceMorphRoll()
						try(addsubrollout  SMStruct.SurfaceMorpherHolder.rollholder surfaceMorpher)catch()
						smstruct.updateui()
						*/
					)
					3:(
						/*
					smstruct.minval=SMStruct.thisobj.minrange[channelindex ]
					smstruct.maxval=SMStruct.thisobj.maxrange[channelindex ]
						createdialog SMStruct.surfaceMorphvalueChanger modal:true
						SMStruct.thisobj.minrange[channelindex ] = smstruct.minval;
						SMStruct.thisobj.maxrange[channelindex ] = smstruct.maxval;
						targList.items.item[whichCell].subitems.item[2].text = smstruct.minval as string
						targList.items.item[whichCell].subitems.item[3].text = smstruct.maxval as string
						
						try(removesubrollout SMStruct.SurfaceMorpherHolder.rollholder surfaceMorpher)catch()
						smstruct.makeDynSurfaceMorphRoll()

						try(addsubrollout  SMStruct.SurfaceMorpherHolder.rollholder surfaceMorpher)catch()
						smstruct.updateui()
						*/
					)
					4:(
						if val == "true" then
						(	targList.items.item[whichCell].subitems.item[whichColumn].text = "false";targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor blue;
						)
						else if val == "false" then
						(	targList.items.item[whichCell].subitems.item[whichColumn].text = "true";targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor red;
						)
					
						SMStruct.thisobj.usetargetselection[channelindex ] = if SMStruct.thisobj.usetargetselection[channelindex ] == 1 then  0 else 1
					
					)
					5:( -- use mapping as mask
						if val == "true" then
						(	targList.items.item[whichCell].subitems.item[whichColumn].text = "false";targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor blue;
						)
						else if val == "false" then
						(	targList.items.item[whichCell].subitems.item[whichColumn].text = "true";targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor red;
						)
					
						SMStruct.thisobj.UseMap[channelindex ] = if SMStruct.thisobj.UseMap[channelindex ] == 1 then  0 else 1
					
					)
					6:(	
						if val == "true" then
						(	targList.items.item[whichCell].subitems.item[whichColumn].text = "false";targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor blue;
						)
						else if val == "false" then
						(	targList.items.item[whichCell].subitems.item[whichColumn].text = "true";targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor red;
						)
					
						SMStruct.thisobj.SetLocalUsePaint channelindex 1  (if SMStruct.thisobj.GetLocalUsePaint channelindex 1 == 1 then  0 else 1)
						SMStruct.thisobj.MorphMode[channelindex ]=SMStruct.thisobj.MorphMode[channelindex ] -- just to force an update
					)
				)
			) else ( -- items count not 2, only a couple to deal with
				channelindex = whichItems[2];
				targetindex = whichItems[3];
				val = targList.items.item[whichCell].subitems.item[whichColumn].text
				
				
				case whichColumn of
				(
					
					1:(
						if val == "true" then
						(	
							targList.items.item[whichCell].subitems.item[whichColumn].text = "false";
							targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor blue;
						)
						else if val == "false" then
						(	
							targList.items.item[whichCell].subitems.item[whichColumn].text = "true";
							targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor red;
						)
					
						SMStruct.thisobj.SetCacheMe channelindex targetindex (if SMStruct.thisobj.GetCacheMe channelindex targetindex == 1 then  0 else 1)
						smstruct.updateStack()
					
					)
					6:(	
						if val == "true" then
						(	targList.items.item[whichCell].subitems.item[whichColumn].text = "false";targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor blue;
						)
						else if val == "false" then
						(	targList.items.item[whichCell].subitems.item[whichColumn].text = "true";targList.items.item[whichCell].subitems.item[whichColumn].forecolor = getNETColor red;
						)
					
						SMStruct.thisobj.SetLocalUsePaint channelindex targetindex  (if SMStruct.thisobj.GetLocalUsePaint channelindex targetindex == 1 then  0 else 1)
						SMStruct.thisobj.MorphMode[channelindex ]=SMStruct.thisobj.MorphMode[channelindex ] -- just to force an update
					)
				)
			
			)
		)
		smstruct.updateChannelUI()
	)
)	
	SMStruct.SurfaceMorpherMain = SurfaceMorpherMain 
rollout SurfaceMorpherPaint "Mask Paint"
(
		
	GroupBox grp2 "Paint - Select a target to work on (selecting a channel affects the first target)      Hold Control to paint positive, Alt to blur" pos:[5,6] width:643 height:122
	checkbutton paintselected "Paint Selected Target" pos:[16,27] width:162 height:27
	checkbox showpaint "Display Paint While Painting" pos:[186,30] width:158 height:18
	spinner showpaintchannel "Temp Channel:" pos:[362,32] width:103 height:16 enabled:false range:[-2,100,-1] type:#integer fieldwidth:20
	checkbutton togglepaintchannel "Toggle Display Selected" pos:[498,25] width:141 height:27
	checkbutton paintBlur "Paint Blur" pos:[16,94] width:159 height:27
	button blurAll "Blur All" pos:[402,92] width:62 height:27
	spinner blurSteps "Blur Steps:" pos:[197,99] width:80 height:16 range:[2,100,5] type:#integer fieldwidth:35
	spinner blurMult "Blur Mult:" pos:[289,97] width:91 height:16 range:[0.0,1,0.2] type:#float fieldwidth:35
	button halfstren "0.5 strength" pos:[479,60] width:76 height:27
	button doubstren "1.0x strength" pos:[562,60] width:76 height:27
	button halfrad "0.5x Radius" pos:[480,93] width:76 height:27
	button doubrad "2x Radius" pos:[562,92] width:76 height:27
	button paintOptions "Options..." pos:[16,58] width:162 height:27
	checkbox colweights "Coloured Weights" pos:[187,49] width:158 height:18
	
	
	fn disableUI =
	(
		--print "disable paint ui"
		blurall.enabled = paintselected.enabled = togglepaintchannel.enabled = false
	)
	fn enableUI =
	(
		blurall.enabled = paintselected.enabled = togglepaintchannel.enabled = true
	
	)
		on halfstren pressed do
		(
			smstruct.thisobj.setpaintproperty 2 0
		)
		on  doubstren pressed do
		(
			smstruct.thisobj.setpaintproperty 3 0
		)
		on halfrad pressed do
		(
			smstruct.thisobj.setpaintproperty 0 0
		)
		on doubrad pressed do
		(
			smstruct.thisobj.setpaintproperty 1 0
		)
		
		
		fn cancelPaint =
		(
			--print "cancelpaint"
			PaintSelected.checked = false;
			if smstruct.wasShowVertexOn == false do
				smstruct.thisNode.showVertexColors = false
			--delete smstruct.paintNode
		)
		on colweights changed val do  smstruct.thisobj.ColorPaintDisplay = if val then 1 else 0;
		on blursteps changed val do smstruct.thisobj.paintblursteps = val;
		on blurmult changed val do smstruct.thisobj.paintblurmult = val;
		on paintBlur changed state do (
			 smstruct.thisobj.PaintBlur = if state then 1 else 0
		)
		on blurall pressed do
		(
			selcount = surfacemorphermain.targlist.selecteditems.count;
			if selcount < 1 do return(togglepaintchannel .state = false);
			whichItems = surfacemorphermain.targList.selecteditems.item[0].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2] as integer;
				targetIndex = 1;
			) else (
			
				channelindex = whichItems[2] as integer;
				targetIndex = whichItems[3] as integer;
				
			)


			SMStruct.thisobj.blurpaintmask SMStruct.thisnode channelindex targetIndex 
			SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
		)
		
		on paintOptions pressed do smstruct.thisObj.openPaintUI();
		on togglepaintchannel changed state do
		(
			if PaintSelected.state do return(togglepaintchannel.state = false);
			selcount = surfacemorphermain.targlist.selecteditems.count;
			if selcount < 1 do return(togglepaintchannel .state = false);
			whichItems = surfacemorphermain.targList.selecteditems.item[0].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2];
				targetIndex = 1;
			) else (			
				channelindex = whichItems[2];
				targetIndex = whichItems[3];
			)

			if state == true then
			(
				smstruct.wasShowVertexOn = smstruct.thisNode.showVertexColors
				smstruct.origVertexShowing= smstruct.thisNode.vertexColorType 
				-- here we toggle the vertex colours
				smstruct.thisNode.showVertexColors = true
				smstruct.thisNode.vertexColorType = #color
				
				smstruct.thisobj.SetPaintTempDisplay channelindex targetIndex 1
				SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
			)else(
				smstruct.thisNode.showVertexColors = smstruct.wasShowVertexOn
				smstruct.thisNode.vertexColorType = smstruct.origVertexShowing
				smstruct.thisobj.SetPaintTempDisplay channelindex targetIndex 0
				SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
			)
		
		
		)
		on PaintSelected changed state do
		(
		--	print  "PaintSelected "
			-- add some callbacks:
			-- add some cleanup callbacks:
			callbacks.addscript #systemPreNew "try(SMStruct.endPaint())catch()" id:#isurMorph
			callbacks.addscript #systemPreReset "try(SMStruct.endPaint())catch()" id:#isurMorph
			callbacks.addscript #filePreSave "try(SMStruct.endPaint())catch()" id:#isurMorph


			togglepaintchannel.state = false
			if not state do (
				paintBlur.state = false
				smstruct.thisobj.PaintBlur = 0; -- turn off internally
			)
			-- first figure out if we have a channel selected
			selcount = surfacemorphermain.targlist.selecteditems.count;
			if selcount < 1 do return(
				PaintSelected.state = false
				callbacks.removescripts id:#isurMorph
			);
			whichItems = surfacemorphermain.targList.selecteditems.item[0].tag.value
			if whichItems[1] == #Channel then
			(
				channelindex = whichItems[2] as integer;
				targetIndex = 1;
			) else (
			
				channelindex = whichItems[2] as integer;
				targetIndex = whichItems[3] as integer;
				
			)
--show smstruct.thisNode
			if showpaint.checked do
			(
				if state == true then
				(
					-- here we toggle the vertex colours
					smstruct.wasShowVertexOn = smstruct.thisNode.showVertexColors
					smstruct.origVertexShowing= smstruct.thisNode.vertexColorType 
					smstruct.thisNode.showVertexColors = true
					smstruct.thisNode.vertexColorType = #color
				)else(
					--if smstruct.wasShowVertexOn == false do
					smstruct.thisNode.showVertexColors = smstruct.thisNode.showVertexColors
					smstruct.thisNode.vertexColorType = smstruct.origVertexShowing
				)
			)
			if state then
			(
				smstruct.paintNode= SMStruct.thisnode;

				SMStruct.thisobj.StartPaint channelindex targetIndex smstruct.paintNode -- this automatically cancels if it is on
				SMStruct.thisobj.DisplayPaint=SMStruct.thisobj.DisplayPaint;
				smstruct.paintingDidTakePlace=true;
			) else
			(
				--print "deleting node..."
				try(SMStruct.endPaint())catch()
				-- try(delete smstruct.paintNode)catch()
				callbacks.removescripts id:#isurMorph
			)
			--// clean up
	)

		on showpaint changed val do
		(
			SMStruct.thisobj.DisplayPaint = if val then 1 else 0;
			if val then
			(
				if PaintSelected.checked do
				(
					smstruct.wasShowVertexOn = smstruct.thisNode.showVertexColors
					smstruct.origVertexShowing= smstruct.thisNode.vertexColorType 
					smstruct.thisNode.showVertexColors = true
				)
			
			) else (
				if PaintSelected.checked do
				(
				
					smstruct.thisNode.showVertexColors = smstruct.wasShowVertexOn
					smstruct.thisNode.vertexColorType = smstruct.origVertexShowing
					smstruct.thisNode.showVertexColors = false
				)
			)
		)

		on showpaintchannel changed val do SMStruct.thisobj.DisplayPaintChannel = val
	
	
)
SMStruct.SurfaceMorpherPaint = SurfaceMorpherPaint 
	rollout SurfaceMorpherHolder "Surface Morpher Controls" width:750 height:692
	(
	
		subRollout rollholder "" pos:[5,14] width:740 height:612
		listBox feedback "" pos:[5,629] width:740 height:4
		
		
		
		on SurfaceMorpherHolder open do
		(
		
			surfaceMorphIni = (getdir #plugcfg) + "/SurfaceMorph.ini"
			mainopen = if (getinisetting surfacemorphini "RolloutStates" "Main") == "true" then false else true;
			Globalsopen = if (getinisetting surfacemorphini "RolloutStates" "Globals") == "true" then false else true;
			Paintopen = if (getinisetting surfacemorphini "RolloutStates" "Paint") == "true" then false else true;
			Controlsopen = if (getinisetting surfacemorphini "RolloutStates" "Controls") == "true" then false else true;
			scrollPos = execute (getinisetting surfacemorphini "RolloutStates" "ScrollPos");
			if scrollpos == OK do scrollpos = 0;

			rollholder.height = SurfaceMorpherHolder.height - 21 - 58
			feedback.pos.y = SurfaceMorpherHolder.height - 62
			print Controlsopen 
			SMStruct.makeDynSurfaceMorphRoll()
			addsubrollout rollholder SMStruct.surfaceMorpherMain rolledup:mainopen 
			addsubrollout rollholder SMStruct.SurfaceMorpherGlobals rolledup:Globalsopen ;
			addsubrollout rollholder SMStruct.SurfaceMorpherPaint rolledup:Paintopen ;
			try(addsubrollout rollholder SMStruct.surfaceMorpher rolledup:Controlsopen )catch()
			SMStruct.SurfaceMorpherMain.initTargetList()
			smstruct.updateGlobalUI()
			smstruct.updateChannelUI()
			smstruct.updateUI()
			SMStruct.surfaceMorpher.open = not Controlsopen 
			try(SMStruct.surfaceMorpherMain.scrollpos = scrollPos )catch()
		)
		on SurfaceMorpherHolder close do
		(
			-- store size and pos
			surfaceMorphIni = (getdir #plugcfg) + "/SurfaceMorph.ini"
			--setinisetting surfacemorphini "Position" "Xsize" ((getdialogsize surfacemorpherholder).x as string)
			setinisetting surfacemorphini "Position" "Ysize" ((getdialogsize surfacemorpherholder).y as string)
			setinisetting surfacemorphini "Position" "Xpos" ((getdialogpos surfacemorpherholder).x as string)
			setinisetting surfacemorphini "Position" "Ypos" ((getdialogpos surfacemorpherholder).y as string)
			setinisetting surfacemorphini "RolloutStates" "Main" (smstruct.surfacemorphermain.open as string)
			setinisetting surfacemorphini "RolloutStates" "Globals" (smstruct.surfaceMorpherGlobals.open as string)
			setinisetting surfacemorphini "RolloutStates" "Paint" (smstruct.surfacemorpherpaint.open as string)
			setinisetting surfacemorphini "RolloutStates" "Controls" (smstruct.surfaceMorpher.open as string)
			setinisetting surfacemorphini "RolloutStates" "ScrollPos" (smstruct.surfacemorphermain.scrollpos as string)
		)
		
		on SurfaceMorpherHolder resized val do
		(
			--print val
			if val.x != 750 do
				SurfaceMorpherHolder.width = 750
			rollholder.height = val.y - 21 - 58
			feedback.pos.y = val.y - 62
		)
		
	)	
	SMStruct.SurfaceMorpherHolder = SurfaceMorpherHolder 

fn Global_OpenSurfaceMorph_UI =
(
	posval = [100,100];
	sizer = [750,692];
	
	surfaceMorphIni = (getdir #plugcfg) + "/SurfaceMorph.ini"
	--Xsize=( getinisetting surfacemorphini "Position" "Xsize") as integer
	Ysize= (getinisetting surfacemorphini "Position" "Ysize")  as integer
	Xpos= (getinisetting surfacemorphini "Position" "Xpos")  as integer
	Ypos= (getinisetting surfacemorphini "Position" "Ypos") as integer

	if Ysize != 0 do sizer.y = ysize
	if Xpos!= 0 do posval.x = Xpos
	if Ypos!= 0 do posval.y = Ypos
	print posval
	print sizer
	
	--if smstruct.dialogposval != undefined do
	--	posval = smstruct.dialogposval;
	if SMStruct.SurfaceMorpherHolder.open  then
	(
			setfocus SMStruct.SurfaceMorpherHolder
		if modPanel.getCurrentObject() == SMStruct.thisObj do return()
		smstruct.dialogposval = getdialogpos SMStruct.SurfaceMorpherHolder
		posval = smstruct.dialogposval
		try (destroydialog SMStruct.SurfaceMorpherHolder)catch()
		if selection.count != 1 do return()
		SMStruct = surfaceMorphStruct()	
		SMStruct = surfaceMorphStruct()	
	SMStruct.SurfaceMorpherHolder = SurfaceMorpherHolder 
SMStruct.SurfaceMorpherPaint = SurfaceMorpherPaint 
	SMStruct.SurfaceMorpherMain = SurfaceMorpherMain 
	SMStruct.SurfaceMorpherGlobals = SurfaceMorpherGlobals 
	SMStruct.surfaceMorphSpinnerChanger = surfaceMorphSpinnerChanger 
		SMStruct.thisObj = modPanel.getCurrentObject();
		SMStruct.thisNode = selection[1]
		smstruct.dialogposval=posval;
		createdialog SMStruct.SurfaceMorpherHolder pos:posval menu:SMMenu width:sizer.x height:sizer.y style:#(#style_titlebar, #style_border, #style_sysmenu, #style_resizing, #style_minimizebox, #style_maximizebox)
		SMStruct.SurfaceMorpherHolder.title+= " : " + selection[1].name
	) else (
		try (destroydialog SMStruct.SurfaceMorpherHolder)catch()
		if selection.count != 1 do return()
		SMStruct = surfaceMorphStruct()	
		SMStruct = surfaceMorphStruct()	
	SMStruct.SurfaceMorpherHolder = SurfaceMorpherHolder 
SMStruct.SurfaceMorpherPaint = SurfaceMorpherPaint 
	SMStruct.SurfaceMorpherMain = SurfaceMorpherMain 
	SMStruct.SurfaceMorpherGlobals = SurfaceMorpherGlobals 
	SMStruct.surfaceMorphSpinnerChanger = surfaceMorphSpinnerChanger 
		SMStruct.thisObj = modPanel.getCurrentObject();
		SMStruct.thisNode = selection[1]
		smstruct.dialogposval=posval;
		createdialog SMStruct.SurfaceMorpherHolder pos:posval menu:SMMenu width:sizer.x height:sizer.y style:#(#style_titlebar, #style_border, #style_sysmenu, #style_resizing, #style_minimizebox, #style_maximizebox)
		SMStruct.SurfaceMorpherHolder.title+= " : " +  selection[1].name
	)
	
)
--Global_OpenSurfaceMorph_UI()--